<?php

namespace HCM\FPA\ObrigacaoLegal\Dirf\Registros;

use HCM\FPA\Registro\FPARegistro;

class RegistroDIRF extends FPARegistro{

    const REGISTRO_DIRF = 'DIRF';
    const REGISTRO_RESPO = 'RESPO';
    const REGISTRO_DECPJ = 'DECPJ';
    const REGISTRO_IDREC = 'IDREC';
    const REGISTRO_BPFDEC = 'BPFDEC';
    const REGISTRO_RTRT = 'RTRT';
    const REGISTRO_RTPO = 'RTPO';
    const REGISTRO_RTDP = 'RTDP';
    const REGISTRO_RTDS = 'RTDS';
    const REGISTRO_RTIRF = 'RTIRF';
    const REGISTRO_RTPA = 'RTPA';
    const REGISTRO_RIDAC = 'RIDAC';
    const REGISTRO_RIIRP = 'RIIRP';
    const REGISTRO_RIAP = 'RIAP';
    const REGISTRO_RIO = 'RIO';
    const REGISTRO_INFPA = 'INFPA';

    const IDE_LEIAUTE_DIRF = 'IDE_LEIAUTE_DIRF';

    const ITEM_RTRT = 1;
    const ITEM_RTPO = 2;
    const ITEM_RTRT_13S_INF = 3;
    const ITEM_RTDP = 4;
    const ITEM_RTPA = 5;
    const ITEM_RTIRF = 6;
    const ITEM_RIAP = 7;
    const ITEM_RIIRP = 8;
    const ITEM_RTPO_13S = 9;
    const ITEM_RTIRF_13S = 10;
    const ITEM_RTRT_13S = 11;
    const ITEM_RTDP_13S = 12;
    const ITEM_RIDAC = 13;
    const ITEM_BASE_DIRF = 14;
    const ITEM_RTRT_FERIAS = 15;
    const ITEM_RTPO_FERIAS = 16;
    const ITEM_RIO = 17;
    const ITEM_RTRT_ESTAG = 18;
    const ITEM_RTPA_13S = 19;
    const ITEM_RIAP_DIFF = 20;
    const ITEM_RTRT_ADIANT_CX = 21;
    const ITEM_RTDS = 22;
    const ITEM_RTDS_13S = 23;
    const ITEM_INFORMACOES_COMPLEMENTARES = 99;

    private $_anoReferencia;
    private $_anoCalendario;
    private $_idTipoDeclarac;
    private $_nrRecibo;
    private $_ideLeiaute;

    public function geraRegistro($tpRegistro, $tpInscricao=null, $nrInscricao=null){
        $this->_geraRegistro(self::REGISTRO_DIRF);
    }

    public function geraRegistroDIRF(){
        $this->_geraRegistro(self::REGISTRO_DIRF);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoDirf($tpRegistro);

        // Ordem 2
        $this->atribuiDadoDirf($this->_anoReferencia);

        // Ordem 3
        $this->atribuiDadoDirf($this->_anoCalendario);

        // Ordem 4
        $this->atribuiDadoDirf($this->_idTipoDeclarac);

        // Ordem 5
        $this->atribuiDadoDirf($this->_nrRecibo);

        // Ordem 6
        $this->atribuiDadoDirf($this->_ideLeiaute);
    }

    public function setAnoReferencia($anoReferencia){
        $this->_anoReferencia = $anoReferencia;
    }
    public function setAnoCalendario($anoCalendario){
        $this->_anoCalendario = $anoCalendario;
    }
    public function setIdTipoDeclarac($idTipoDeclarac){
        $this->_idTipoDeclarac = $idTipoDeclarac;
    }
    public function setNrRecibo($nrRecibo){
        $this->_nrRecibo = $nrRecibo;
    }
    public function setIdeLeiaute($ideLeiaute){
        $this->_ideLeiaute = $ideLeiaute;
    }

}