<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class AssociacaoContabilRepository {
    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function getEventoCtbl($nrorg, $nrorgpadrao, $nreventom, $dtcompetencia, $cdDebCtbl, $histDebCtbl, $cdCreCtbl, $histCreCtbl, $nrtpeventoctbl) {
        $sql = <<<SQL
    SELECT
      *
    FROM
      FPA_EVENTOCTBL
    WHERE
      NRORG IN (
        :P_NRORG,
        :P_NRORG_PADRAO
      )
      AND NREVENTOM = :P_NREVENTOM
      AND (
        DTFIMVIGENCIA >= :P_DTMESCOMPETENC
        OR DTFIMVIGENCIA IS NULL
      )
      AND DTINIVIGENCIA <= :P_DTMESCOMPETENC
      AND CDCONTCTBLDEB = :P_CDCONTCTBLDEB
      AND CDHISTPADRDEB = :P_CDHISTPADRDEB
      AND CDCONTCTBLCRE = :P_CDCONTCTBLCRE
      AND CDHISTPADRCRE = :P_CDHISTPADRCRE
      AND NRTPEVENTOCTBL = :P_NRTPEVENTOCTBL
      AND NRESTRUTURAM IS NULL
SQL;
    // ao fazer a importação olhar para estrutura, retirar o "AND NRESTRUTURAM IS NULL"


        $params = array(
            'P_NRORG'           => $nrorg,
            'P_NRORG_PADRAO'    => $nrorgpadrao,
            'P_NREVENTOM'       => intval($nreventom),
            'P_DTMESCOMPETENC'  => $dtcompetencia->format('d/m/Y'),
            'P_CDCONTCTBLDEB'   => $cdDebCtbl,
            'P_CDHISTPADRDEB'   => $histDebCtbl,
            'P_CDCONTCTBLCRE'   => $cdCreCtbl,
            'P_CDHISTPADRCRE'   => $histCreCtbl,
            'P_NRTPEVENTOCTBL'  => $nrtpeventoctbl
            
        );
        
        return $this->connection->fetchAll($sql, $params);
    }
    
}