<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\HCMParameters;

class LoteVinculoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function existeLote($nrorg, $nmLoteVinc)
    {
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT LT.*
            FROM FPA_LOTEVINC LT
            WHERE ( LT.NRORG = :P_NRORG
            AND LT.NMLOTEVINC = :P_NMLOTEVINC
            )"
        );
        
        $sql->execute(
            array(
                "P_NMLOTEVINC"       => $nmLoteVinc,
                "P_NRORG"            => $nrorg
            )
        );

        return $sql->fetch();
    }

    public function existeVinculoNoLote($nrorg, $nrLoteVinc, $nrvinculom)
    {
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT ITLT.*
            FROM FPA_ITEMLOTEVINC ITLT
            WHERE (ITLT.NRORG = :P_NRORG
            AND ITLT.NRLOTEVINC = :P_NRLOTEVINC
            AND ITLT.NRVINCULOM = :P_NRVINCULOM
            )"
        );
        
        $sql->execute(
            array(
                "P_NRLOTEVINC"       => $nrLoteVinc,
                "P_NRORG"            => $nrorg,
                "P_NRVINCULOM"       => $nrvinculom
            )
        );

        return $sql->fetch();
    }

    public function selectExisteItensFilhos($nrorg, $nrLoteVinc) {
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT ITLT.* FROM FPA_ITEMLOTEVINC ITLT WHERE (ITLT.NRORG = :P_NRORG AND ITLT.NRLOTEVINC = :P_NRLOTEVINC )"
            );
            
            $sql->execute(
                array(
                    'P_NRORG' => $nrorg,
                    "P_NRLOTEVINC" => $nrLoteVinc
                )
            );
          
            return $sql->fetch();
    }
}
