<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomDirfRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function arrayToList($array, $espacador) {
        $lista = array_map(function($val){return $val;}, $array);
        return implode($espacador, $lista);
    }
    
    /**
     * @return array
     */

    public function getRelatCustomDirf($parameters, $filters) {
        //Montagem dos parâmetros
        $params = array(
            'nrorg' => $parameters['P_NRORG'],
            'dtcompetencia' => $parameters['P_DTMESCOMPETENC'],
            'nrtpmodalidcal' => $parameters['NRTPMODALIDCAL'],
            'nrgrupoinciden' => $parameters['NRGRPDIRF'],
            'nrregimeapur' => $parameters['NRREGIMEAPUR'],
            "P_NRVINCULOM"     => null,
            "P_NRPESSOA"       => null,
            "P_NRESTRUTLEGAL"  => null,
            "P_NRESTRUTGEREN"  => null,
        );
        
        if(array_key_exists('NRVINCULOM', $parameters))
            $params["P_NRVINCULOM"] = $parameters["NRVINCULOM"];
        
        if(array_key_exists('NRPESSOA', $parameters))
            $params["P_NRPESSOA"] = $parameters["NRPESSOA"];
        
        if(array_key_exists('NRESTRUTLEGAL', $parameters))
            $params["P_NRESTRUTLEGAL"] = $this->arrayToList($parameters['NRESTRUTLEGAL'], ',');
        
        if(array_key_exists('NRESTRUTGEREN', $parameters))
            $params["P_NRESTRUTGEREN"] = $this->arrayToList($parameters['NRESTRUTGEREN'], ',');
        
        if(array_key_exists('NREVENTOM', $parameters))
            $params["P_NREVENTOM"] = $this->arrayToList($parameters['NREVENTOM'], ',');
        
        /*if(array_key_exists('IDDADOSVINC', $parameters))
            $params["P_IDDADOSVINC"] = $parameters['IDDADOSVINC'];
        
        if(array_key_exists('MES', $parameters))
            $params["P_MES"] = '%'.$parameters['MES'].'%';*/
        
        //Query principal
        $sql = "
SELECT
    VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, PH.NRCPFPESSOA, PH.NMPESSOA, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VM.NRTIPOVINCULOM, VM.NRVINCULOEMPREG, VM.NMVINCULOM,
    VH.DTMESCOMPETENC, VH.NRESTRUTLEGAL, EML.NMESTRUTURAM NMESTRUTLEGAL, VH.NRESTRUTGEREN, EMG.NMESTRUTURAM NMESTRUTGEREN, VH.NRESTRUTSIND,
    CF.NRCALCULOFOLHA, CF.NRTIPOMOVIMENT, CF.NRTPMODALIDCAL, CF.NROCORRECAL, CF.DTOCORRENCIA AS DTOCORRENCIACALC,
    ICF.NRITEMCALCFOLHA, ICF.NREVENTOM, EH.NMEVENTOH, ICF.VRREFFOLHA, ICF.VREVENTOFOLHA, ICF.IDREFEVALORCALC, ICF.DTOCORRENCIA,
    IEV.NRTIPOINCIDE, TPI.NMTIPOINCIDE, TPM.NMTIPOMOVIMENT,
    REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, '-13S', ''), '-FERIAS', ''), '-ESTAG', ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') NMITEM, /*Remove a idêntificação do 13º salário (este vai para o M13 e VALOR13)*/
    CASE
      WHEN ICF.NREVENTOM = 870 THEN '3562'
      ELSE LPAD(VE.CODRECEITA, 4, '0')
    END CDRECEITA,
    CASE
      /*2 0*/
        WHEN :nrregimeapur = 2 AND GIT.NMITEM = 'RTRT' AND RESC.DTOCORRENCIARESC IS NOT NULL THEN TO_CHAR(RESC.DTOCORRENCIARESC, 'yyyymm')
      WHEN INSTR(GIT.NMITEM, '-13S') > 0 THEN TO_CHAR(TO_DATE(:dtcompetencia), 'yyyy')||'13' /*Verifica se o item é do 13º salário (Ex. se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
      /*2 1*/ /*RegimeCaixa*/
        WHEN :nrregimeapur = 2 AND ICF.NREVENTOM = 1390 THEN TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
        WHEN :nrregimeapur = 2 AND CF.NRTIPOMOVIMENT = 1 AND (VM.DTRESCISAOVINC IS NULL OR TO_CHAR(CF.DTOCORRENCIA,'MMYYYY') <> TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY')) THEN TO_CHAR(TO_DATE(:dtcompetencia), 'YYYY') || TO_CHAR(ADD_MONTHS(CF.DTOCORRENCIA, 1),'MM')
      WHEN GIT.NMITEM = 'RTPO-FERIAS' AND ICF.NREVENTOM IN (1140) THEN TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
      WHEN GIT.NMITEM = 'RTPO-FERIAS' AND ICF.NREVENTOM IN (1145) THEN TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
      /*1 8*/ /*RegimeCompetencia*/
        WHEN :nrregimeapur <> 2 AND GIT.NMITEM = 'RTPO' AND ICF.NREVENTOM IN (1140,1145) THEN TO_CHAR(ICF.DTOCORRENCIA, 'yyyymm')
      /*2 8*/ /*RegimeCaixa*/
        WHEN :nrregimeapur = 2 AND GIT.NMITEM = 'RTPO' AND ICF.NREVENTOM IN (1140,1145) THEN TO_CHAR(ADD_MONTHS(ICF.DTOCORRENCIA,1), 'yyyymm')
      /*2 2*/
        WHEN :nrregimeapur = 2 AND GIT.NMITEM = 'RTRT-ADIANT-CX' THEN TO_CHAR(ICF.DTOCORRENCIA, 'yyyymm')
        WHEN :nrregimeapur = 2 AND GIT.NMITEM = 'RTRT-ADIANT-CX-ANT' AND VM.DTRESCISAOVINC IS NOT NULL AND TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY') = TO_CHAR(ICF.DTOCORRENCIA, 'MMYYYY') THEN TO_CHAR(ICF.DTOCORRENCIA, 'yyyymm')
        WHEN :nrregimeapur = 2 AND GIT.NMITEM = 'RTRT-ADIANT-CX-ANT' THEN TO_CHAR(ADD_MONTHS(ICF.DTOCORRENCIA, 1), 'yyyymm')
      ELSE TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
    END MES, /*são as colunas do pivô*/
    CASE
      WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º na rescisao caso não possua data de rescisão*/
      AND VM.DTRESCISAOVINC IS NULL AND IEV.NREVENTOM IN (600,1180)
      THEN 0
      WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º caso possua data de rescisão*/
      AND VM.DTRESCISAOVINC IS NOT NULL AND VM.DTRESCISAOVINC <= (TO_DATE(:dtcompetencia)+19) AND IEV.NREVENTOM IN (110,125,1150) /*Rescisoes ate o dia 20 nao tem 13o*/
      THEN 0
      WHEN GIT.NMITEM IN ('RTRT-ESTAG') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
      AND VM.NRTIPOVINCULOM <> 2 /*Estagiário*/
      THEN 0
      WHEN GIT.NMITEM IN ('RTDS', 'RTDS-13S') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
      THEN CASE 
             WHEN DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) > 0 AND GIT.VRPISOEVENTO IS NOT NULL AND GIT.VRPISOEVENTO > 0 AND DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) < GIT.VRPISOEVENTO
             THEN GIT.VRPISOEVENTO
             ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA))
           END
      /*2 3*/
        WHEN :nrregimeapur = 2 AND GIT.NMITEM IN ('RTRT-ADIANT-CX') /*Subtrai o adiantamento do mês para entrar no mês anterior*/
        THEN DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) * (-1)
      ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
    END VREVENTOFOLHA, GIT.NMITEM AS NMITEMORIG, GIT.DSITEM, GIT.VRPISOEVENTO, GIT.VRTETOEVENTO
  FROM FPA_CALCULOFOLHA CF
  JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG = CF.NRORG
                           AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                           AND ICF.VREVENTOFOLHA > 0
  
  /*Movimento*/
  JOIN FPA_TIPOMOVIMENT TPM ON ( TPM.NRORG = CF.NRORG OR TPM.NRORG = 0 )
                           AND TPM.NRTIPOMOVIMENT = CF.NRTIPOMOVIMENT
  
  /*Vinculo*/
  JOIN GPE_VINCULOM VM ON VM.NRORG = ICF.NRORG
                      AND VM.NRVINCULOM = ICF.NRVINCULOM
                      AND ( VM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL )
                      AND ( VM.NRPESSOA   = :P_NRPESSOA   OR :P_NRPESSOA   IS NULL )
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                      AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGEREN IS NULL )
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM (SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                WHERE H1.NRORG = VH.NRORG
                                                  AND H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.DTMESCOMPETENC <= CF.DTOCORRENCIA ORDER BY H1.DTMESCOMPETENC DESC) WHERE ROWNUM = 1)
      
  /*CPF e Nome do vínculo em questão (item 3.6)*/
  JOIN GPE_PESSOA  PE ON PE.NRORG    = VM.NRORG
                     AND PE.NRPESSOA = VM.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRORG    = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE DTMESCOMPETENC <= TO_DATE(:dtcompetencia,'DD/MM/YYYY')
                                                 AND NRORG    = PH.NRORG
                                                 AND NRPESSOA = PH.NRPESSOA )
                                                 
  /*Estrutura Legal*/
  LEFT JOIN ESTRUTURAM EML ON EML.NRORG        = VH.NRORG
                          AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  /*Estrutura Gerencial*/
  LEFT JOIN ESTRUTURAM EMG ON EMG.NRORG        = VH.NRORG
                          AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
  
  /*Código da receita do vínculo em questão (item 3.5)*/
  LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
      
  /*Evento*/
  JOIN FPA_EVENTOH EH ON EH.NREVENTOM      = ICF.NREVENTOM
                     AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH E 
                                              WHERE E.NRORG           = EH.NRORG
                                                AND E.NREVENTOM       = EH.NREVENTOM
                                                AND E.DTMESCOMPETENC <= TO_DATE(:dtcompetencia,'DD/MM/YYYY'))
  
  /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
  JOIN (SELECT GIT.NRORG, GIT.NRITEM, GIT.NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE, GIT.DSITEM, GIT.VRPISOEVENTO, GIT.VRTETOEVENTO
          FROM FPA_GRPITEM GIT
         WHERE (GIT.NRORG = :nrorg OR GIT.NRORG = 0)
           AND GIT.NRGRPINCIDE  = :nrgrupoinciden
        /*2 4*/ /*RegimeCaixa*/
        UNION ALL
        SELECT GIT.NRORG, GIT.NRITEM, 'RTRT-ADIANT-CX-ANT' AS NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE, GIT.DSITEM, GIT.VRPISOEVENTO, GIT.VRTETOEVENTO
          FROM FPA_GRPITEM GIT
         WHERE (GIT.NRORG = :nrorg OR GIT.NRORG = 0)
           AND GIT.NRGRPINCIDE  = :nrgrupoinciden
           AND GIT.NMITEM = 'RTRT-ADIANT-CX'
           AND :nrregimeapur = 2) GIT ON ( GIT.NRORG = ICF.NRORG OR GIT.NRORG = 0 )
                                     AND GIT.NRGRPINCIDE  = :nrgrupoinciden
  JOIN FPA_INCIDEVENTO IEV ON ( IEV.NRORG = ICF.NRORG OR IEV.NRORG = 0 )
                          AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                          AND IEV.NREVENTOM = ICF.NREVENTOM
  JOIN FPA_TIPOINCIDE  TPI ON TPI.NRTIPOINCIDE = IEV.NRTIPOINCIDE
  
  LEFT JOIN (SELECT RESC.NRVINCULOM, RESC.DTOCORRENCIA AS DTOCORRENCIARESC, CFR.DTOCORRENCIA AS DTOCORRENCIACALC
               FROM FPA_CALCULOFOLHA CFR
               JOIN FPA_ITECALCFOLHA RESC ON RESC.NRORG = CFR.NRORG
                                         AND RESC.NRCALCULOFOLHA = CFR.NRCALCULOFOLHA
                                         AND RESC.NREVENTOM = 3050
              WHERE CFR.NRORG = :nrorg
                AND CFR.NRTIPOMOVIMENT = 1
                AND CFR.NRTPMODALIDCAL = 1
                AND CFR.NROCORRECAL = 1) RESC ON RESC.DTOCORRENCIACALC = TRUNC(VM.DTRESCISAOVINC,'MONTH')
                                             AND RESC.DTOCORRENCIACALC = CF.DTOCORRENCIA
                                             AND RESC.NRVINCULOM = VM.NRVINCULOM
 WHERE CF.NRORG = :nrorg
   AND CF.NRTPMODALIDCAL = :nrtpmodalidcal
   AND (VM.DTRESCISAOVINC IS NULL OR (VM.DTRESCISAOVINC >= TRUNC(TO_DATE(:dtcompetencia),'YEAR' )))
   AND (CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP-DIFF', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-FERIAS', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ESTAG', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-FERIAS', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDS', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDS', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDS-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 8)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 8)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-13S-INF', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 8)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA-13S', 8)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 8)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIO', 1)
        /*2 5*/ /*RegimeCaixa*/
            OR (:nrregimeapur = 2 AND CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ADIANT-CX', 10))
            OR (:nrregimeapur = 2 AND CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT-ADIANT-CX-ANT', 10)) )
        /*2 6*/
            AND ((:nrregimeapur = 2 AND CF.DTOCORRENCIA BETWEEN 
                                                DECODE(CF.NRTIPOMOVIMENT, 2, ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'), -1),
                                                                            10, ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'), -1),
                                                                            1, ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'), -1),
                                                                            4, TO_DATE(:dtcompetencia),
                                                                            TRUNC(TO_DATE(:dtcompetencia),'YEAR'))
                                                AND 
                                                DECODE(CF.NRTIPOMOVIMENT, 1, DECODE(TO_CHAR(VM.DTRESCISAOVINC, 'MMYYYY'), TO_CHAR(CF.DTOCORRENCIA,'MMYYYY'), :dtcompetencia, ADD_MONTHS(:dtcompetencia, -1)), 
                                                                             :dtcompetencia)) OR
        /*1 6*/
                (:nrregimeapur <> 2 AND CF.DTOCORRENCIA BETWEEN 
                                                DECODE(CF.NRTIPOMOVIMENT, 2, ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'),-1), 4, TO_DATE(:dtcompetencia), TRUNC(TO_DATE(:dtcompetencia ),'YEAR'))
                                                AND
                                                :dtcompetencia))
   AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT, 10, DECODE(ICF.NREVENTOM, 475, 475, DECODE(CF.DTOCORRENCIA, TO_DATE(:dtcompetencia), 1390, 0)), ICF.NREVENTOM)
   AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT,  1, DECODE(ICF.NREVENTOM, 205239, 0, 205543, 0, ICF.NREVENTOM), ICF.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
   AND GIT.NRITEM != 99 /*Todos os itens, exceto o 'informações complementares'*/
   AND EXISTS ( SELECT 1
                  FROM FPA_ITECALCFOLHA
                 WHERE NRORG = ICF.NRORG
                   AND NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
                   AND NRVINCULOM = ICF.NRVINCULOM
                   AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = ICF.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                   AND VREVENTOFOLHA > 0 )
        ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($params);

        return $query->fetchAll();
    }
}

