<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 25/08/2017
 * Time: 10:22
 */
namespace HCM\Geral\Factory;

use Doctrine\ORM\EntityManager;
use HCM\Geral\Repository\ESocialEventoCadIniRepository;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;

class ESocialCadIniFactory {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ESocialEventoCadIniRepository $eSocialEventoCadIniRepository)
    {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->eSocialEventoCadIniRepository = $eSocialEventoCadIniRepository;
    }

    /* Evento S-1000 */
    public function getDadosS1000($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1000($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRTPAMBIENTE'], $parametros['DTMESCOMPETENC']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1000softwareHouse($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosSoftwareHouse();
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    /* Evento S-1005 */
    public function getDadosS1005($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1005($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRTPAMBIENTE'], $parametros['DTMESCOMPETENC']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1005infoEntEduc($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1005infoEntEduc($parametros['NRESTRUTURAM']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    /* Evento S-1010 */
    public function getDadosS1010($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1010($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRTABELA'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1020 */
    public function getDadosS1020($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1020($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE'], $parametros['DTMESCOMPETENC']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1030 */
    public function getDadosS1030($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1030($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1040 */
    public function getDadosS1040($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1040($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1050 */
    public function getDadosS1050($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1050($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1050horarioIntervalo($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1050horarioIntervalo($parametros['NRORG'], $parametros['NRHORDIAM']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1060 */
    public function getDadosS1060($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1060($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE'], $parametros['DSVERSAO']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1060fatorRisco($parametros) {
        try {
            if ($parametros['DSVERSAO'] == '2.4.02') {
                $dados = $this->eSocialEventoCadIniRepository->getDadosS1060fatorRisco($parametros['NRORG'], $parametros['NRESTRUTURAM']);
            } else {
                $dados = array();
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }


    /* Evento S-1070 */
    public function getDadosS1070($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1070($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $parametros['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1070infoSusp($parametros) {
        try {
            $dados = $this->eSocialEventoCadIniRepository->getDadosS1070infoSusp($parametros['NRORG'], $parametros['NRPROCESSADMJUD']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

}