/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MAPIMPRLOJA                                              */
/* Tabela : Mapeamento de Impressora Loja                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 30/01/2013 - LEONARDO MATOS                                                */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MAPIMPRLOJA'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
   DROP TRIGGER DTULTATU_MAPIMPRLOJA
GO

CREATE TRIGGER DTULTATU_MAPIMPRLOJA
ON MAPIMPRLOJA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MAPIMPRLOJA', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDLOJA='+CDLOJA +';'+'CDPORTAIMPR='+CDPORTAIMPR +';',
                                                             CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MAPIMPRLOJA
      SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(MAPIMPRLOJA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(MAPIMPRLOJA.CDLOJA,0) = ISNULL(INSERTED.CDLOJA,0)) AND
            (ISNULL(MAPIMPRLOJA.CDPORTAIMPR,0) = ISNULL(INSERTED.CDPORTAIMPR,0));
   END;
END;
GO

UPDATE MAPIMPRLOJA SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATU' and
            type = 'D')
   ALTER TABLE MAPIMPRLOJA DROP CONSTRAINT DEFAULT_DTULTATU
GO

ALTER TABLE MAPIMPRLOJA ADD CONSTRAINT DEFAULT_DTULTATU
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_MAPIMPRLOJA','5.50.000';
GO

